<?php
namespace Importacao\Logic\IO;

class DownloadTemplate
{
    const ID_ESTRUTURA                   = 1;
    const ID_OCUPACAO                    = 2;
    const ID_ESCALA_DE_TRABALHO          = 3;
    const ID_VINCULO                     = 4;
    const ID_DEPENDENTE                  = 5;
    const ID_ALTERACAO_SALARIAL          = 6;
    const ID_ALTERACAO_ESCALA            = 7;
    const ID_ALTERACAO_OCUPACAO          = 8;
    const ID_SITUACAO_FUNCIONAL          = 9;
    const ID_FERIAS                      = 10;
    const ID_EVENTO                      = 11;
    const ID_MOVIMENTACOES_ESTRUTURAS    = 12;
    const ID_MOVIMENTOS_FINANCEIROS      = 13;
    const ID_ESPECICACAO_MIGRACAO        = 9999;

    const RAIZ_PROJETO                    = APP_PATH;
    const CAMINHO_PADRAO_ARQUIVOS         = "/files/download";

    const ARQUIVO_ESTRUTURA               = "/1_Estrutura.xls";
    const ARQUIVO_OCUPACAO                = "/2_Ocupacao.xls";
    const ARQUIVO_ESCALA_TRABALHO         = "/3_EscalaTrabalho.xls";
    const ARQUIVO_FUNCIONARIO             = "/4_Vinculo.xls";
    const ARQUIVO_DEPENDENTE              = "/5_Dependente.xls";
    const ARQUIVO_ALTERACAO_SALARIAL      = "/6_AlteracaoSalarial.xls";
    const ARQUIVO_ALTERACAO_ESCALA        = "/7_AlteracaoEscala.xls";
    const ARQUIVO_ALTERACAO_OCUPACAO      = "/8_AlteracaoOcupacao.xls";
    const ARQUIVO_SITUACAO_FUNCIONAL      = "/9_AlteracaoSituacaoFuncional.xls";
    const ARQUIVO_FERIAS                  = "/10_Ferias.xls";
    const ARQUIVO_EVENTOS                 = "/11_Eventos.xls";
    const ARQUIVO_MOVIMENTACAO            = "/12_Transferencia.xls";
    const ARQUIVO_MOVIMENTACAO_FINANCEIRA = "/13_MovimentoFinanceiro.xls";
    const ARQUIVO_ESPECICACAO_MIGRACAO    = "/Especificação_Migração_HRM.pdf";

    public static function downloadArquivo($idArquivo)
    {
        $caminhoArquivo = self::getCaminhoArquivo($idArquivo);
        $file = new \TkFile($caminhoArquivo);
        $file->download();
    }

    private static function getCaminhoArquivo($idArquivo)
    {

        $filePath = "";
        switch ($idArquivo) {
            case self::ID_ESTRUTURA:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ESTRUTURA;
                break;
            case self::ID_OCUPACAO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_OCUPACAO;
                break;
            case self::ID_ESCALA_DE_TRABALHO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ESCALA_TRABALHO;
                break;
            case self::ID_VINCULO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_FUNCIONARIO;
                break;
            case self::ID_DEPENDENTE:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_DEPENDENTE;
                break;
            case self::ID_ALTERACAO_SALARIAL:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ALTERACAO_SALARIAL;
                break;
            case self::ID_ALTERACAO_ESCALA:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ALTERACAO_ESCALA;
                break;
            case self::ID_ALTERACAO_OCUPACAO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ALTERACAO_OCUPACAO;
                break;
            case self::ID_SITUACAO_FUNCIONAL:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_SITUACAO_FUNCIONAL;
                break;
            case self::ID_FERIAS:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_FERIAS;
                break;
            case self::ID_EVENTO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_EVENTOS;
                break;
            case self::ID_MOVIMENTOS_FINANCEIROS:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_MOVIMENTACAO_FINANCEIRA;
                break;
            case self::ID_MOVIMENTACOES_ESTRUTURAS:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_MOVIMENTACAO;
                break;
            case self::ID_ESPECICACAO_MIGRACAO:
                $filePath = self::RAIZ_PROJETO.self::CAMINHO_PADRAO_ARQUIVOS.self::ARQUIVO_ESPECICACAO_MIGRACAO;
                break;
            default:
                throw new \Importacao\Logic\IO\Exception\TipoDeTemplateNaoEncontrado();
        }

        return realpath($filePath);
    }

}